> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.ordergroove.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.ordergroove.com/_mcp/server.

# Update Components

POST https://restapi.ordergroove.com/subscriptions/{subscription_public_Id}/components/bulk_operation/
Content-Type: application/json

Atomically modify (create, update, and/or delete) components associated with a subscription

Reference: https://developer.ordergroove.com/reference/rest-rpc-api/components/update-components

## Authentication

- `x-api-key` header (required) — Application API Scope — server-to-server, sent in the `x-api-key` header. See [Authentication](/api-reference/authentication).
- `authorization` header (required) — Storefront API Scope — client-side, scoped to one customer, sent as a signature in the `authorization` header. See [Authentication](/api-reference/authentication).

## Request

### Path parameters

- `subscription_public_Id` (string, required) — Unique subscription ID

### Body (application/json)

This endpoint expects an object.

- `create` (list of SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostRequestBodyContentApplicationJsonSchemaCreateItems, optional) — Bundle Components to create with product and its quantity
- `update` (list of SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostRequestBodyContentApplicationJsonSchemaUpdateItems, optional) — Bundle Components to be updated with fields to change
- `delete` (list of string, optional) — Bundle components public ids to be deleted ["85eae83c245111eeb185acde48001122","b3928a0c3c4211eeac2bacde48001122"]

## Response

### 200

200

- `created` (list of SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaCreatedItems, optional)
- `updated` (list of SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaUpdatedItems, optional)
- `deleted` (list of SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaDeletedItems, optional)

## Errors

### 400 Bad Request Error

400

### 404 Not Found Error

404

- `any`

## Types

### SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostRequestBodyContentApplicationJsonSchemaCreateItems

- `product` (string, required) — The id of the product that is being added to the bundle
- `quantity` (integer, required, default: 1) — The quantity of the product being added

### SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostRequestBodyContentApplicationJsonSchemaUpdateItems

- `public_id` (string, required) — The id of the component to be modified
- `quantity` (integer, optional) — The new quantity to set for the component
- `product` (string, optional) — The new product to set for the component

### SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaCreatedItems

- `public_id` (string, optional)
- `product` (string, optional)
- `quantity` (integer, optional, default: 0)

### SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaUpdatedItems

- `public_id` (string, optional)
- `product` (string, optional)
- `quantity` (integer, optional, default: 0)

### SubscriptionsSubscriptionPublicIdComponentsBulkOperationPostResponsesContentApplicationJsonSchemaDeletedItems

- `public_id` (string, optional)
- `product` (string, optional)
- `quantity` (integer, optional, default: 0)

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "created": [
    {
      "public_id": "c5a95e1a3c8711eeaea2acde48001122",
      "product": "new_product_1",
      "quantity": 2
    },
    {
      "public_id": "df2b47a43c8711eeaea2acde48001122",
      "product": "new_product_2",
      "quantity": 1
    }
  ],
  "updated": [
    {
      "public_id": "b3928a0c3c4211eeac2bacde48001122",
      "product": "existing_product_1",
      "quantity": 2
    }
  ],
  "deleted": [
    {
      "public_id": "da850a7c3c4211eeac2bacde48001122",
      "product": "existing_product_2",
      "quantity": 2
    }
  ]
}
```

**SDK Code**

```python Result
import requests

url = "https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/"

payload = {}
headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Result
const url = 'https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/';
const options = {
  method: 'POST',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Result
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Result
require 'uri'
require 'net/http'

url = URI("https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java Result
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php Result
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Result
using RestSharp;

var client = new RestClient("https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/");
var request = new RestRequest(Method.POST);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Result
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://restapi.ordergroove.com/subscriptions/subscription_public_Id/components/bulk_operation/")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```